package knockmonitor;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MainFrame extends javax.swing.JFrame {
    OptionsDB optionsDB; 
    KnockThread thread;
    
    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                thread.bStop = true;                
                System.exit(0);
            }
        });
        optionsDB = new OptionsDB();
        thread = new KnockThread(optionsDB, taOutput);
        thread.start();     
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        pmMenu = new javax.swing.JPopupMenu();
        miCopy = new javax.swing.JMenuItem();
        miClear = new javax.swing.JMenuItem();
        jScrollPane1 = new javax.swing.JScrollPane();
        taOutput = new javax.swing.JTextArea();
        jMenuBar1 = new javax.swing.JMenuBar();
        mnFile = new javax.swing.JMenu();
        miExit = new javax.swing.JMenuItem();
        mnTools = new javax.swing.JMenu();
        miOptions = new javax.swing.JMenuItem();
        mnHelp = new javax.swing.JMenu();
        miAbout = new javax.swing.JMenuItem();

        miCopy.setText("Copy");
        miCopy.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                miCopyActionPerformed(evt);
            }
        });

        pmMenu.add(miCopy);

        miClear.setText("Clear");
        miClear.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                miClearActionPerformed(evt);
            }
        });

        pmMenu.add(miClear);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("KnockMonitor");
        setFocusCycleRoot(false);
        taOutput.setColumns(20);
        taOutput.setComponentPopupMenu(pmMenu);
        taOutput.setEditable(false);
        taOutput.setRows(5);
        jScrollPane1.setViewportView(taOutput);

        mnFile.setMnemonic('F');
        mnFile.setText("File");
        miExit.setText("Exit");
        miExit.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jMenuItem2ActionPerformed(evt);
                miExitActionPerformed(evt);
            }
        });

        mnFile.add(miExit);

        jMenuBar1.add(mnFile);

        mnTools.setMnemonic('T');
        mnTools.setText("Tools");
        mnTools.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                mnToolsActionPerformed(evt);
            }
        });

        miOptions.setMnemonic('O');
        miOptions.setText("Options");
        miOptions.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                miOptionsActionPerformed(evt);
            }
        });

        mnTools.add(miOptions);

        jMenuBar1.add(mnTools);

        mnHelp.setMnemonic('e');
        mnHelp.setText("Help");
        miAbout.setMnemonic('A');
        miAbout.setText("About");
        miAbout.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                miAboutActionPerformed(evt);
            }
        });

        mnHelp.add(miAbout);

        jMenuBar1.add(mnHelp);

        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 605, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 455, Short.MAX_VALUE)
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void mnToolsActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_mnToolsActionPerformed
    {//GEN-HEADEREND:event_mnToolsActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_mnToolsActionPerformed

    private void miCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miCopyActionPerformed
        taOutput.copy();
    }//GEN-LAST:event_miCopyActionPerformed

    private void miClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miClearActionPerformed
        taOutput.setText("");
    }//GEN-LAST:event_miClearActionPerformed

    private void miAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miAboutActionPerformed
        AboutDialog dlg = new AboutDialog(this, true);    
        
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        dlg.setLocation((d.width-dlg.getWidth())/2, (d.height-dlg.getHeight())/2);
        
        dlg.setVisible(true);
    }//GEN-LAST:event_miAboutActionPerformed

    private void miOptionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miOptionsActionPerformed
	OptionsDlg dlg = new OptionsDlg(this, true, optionsDB);
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        dlg.setLocation((d.width-dlg.getWidth())/2, (d.height-dlg.getHeight())/2);
        dlg.setVisible(true);
    }//GEN-LAST:event_miOptionsActionPerformed

    private void miExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miExitActionPerformed
        System.exit(0);
    }//GEN-LAST:event_miExitActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem2ActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                JFrame frm = new MainFrame();
                // make the window appear in the center of the screen
                Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                frm.setLocation((d.width-frm.getWidth())/2, (d.height-frm.getHeight())/2);
                
                frm.setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JMenuItem miAbout;
    private javax.swing.JMenuItem miClear;
    private javax.swing.JMenuItem miCopy;
    private javax.swing.JMenuItem miExit;
    private javax.swing.JMenuItem miOptions;
    private javax.swing.JMenu mnFile;
    private javax.swing.JMenu mnHelp;
    private javax.swing.JMenu mnTools;
    private javax.swing.JPopupMenu pmMenu;
    private javax.swing.JTextArea taOutput;
    // End of variables declaration//GEN-END:variables
    
}
