package knockmonitor;
import java.util.*;
import java.io.*;

public class OptionsDB {
    static final String PATH = "optionsdb";    
    public String logFileName = "";
    public String chxPfConLocation = "";
    public int port = 0;
    public Vector<String> sequence = new Vector<String>();
    public boolean optionsChanged = false;
    public OptionsDB() {
        loadOptions();
    }
    public void loadOptions() {
        File f = new File(PATH);        
        if (!f.exists())
            return;
        try
        {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
            logFileName = (String)in.readObject();
            port = (Integer)in.readObject();
            sequence = (Vector)in.readObject();
            chxPfConLocation = (String)in.readObject();
            in.close();
        }
        catch(Exception ex)
        {
            ex.printStackTrace();            
        }
    }    
    public void saveOptions(String logFileName, int port, Vector<String> sequence, String chxPfConLocation) {
        synchronized (this) {
            this.logFileName = logFileName;
            this.port = port;
            this.sequence = sequence;
            this.chxPfConLocation = chxPfConLocation;
            notify();
        }          
        try
        {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(PATH));            
            out.writeObject(logFileName);
            out.writeObject(port);
            out.writeObject(sequence);
            out.writeObject(chxPfConLocation);
            out.close();
	    optionsChanged = true;
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }
}
