package knockmonitor;
import javax.swing.*;
import java.io.*;
import java.util.*;

public class OptionsDlg extends javax.swing.JDialog
{
    OptionsDB optionsDB;
    DefaultListModel lstModel = new DefaultListModel();
    private int lastSelectedIndex;
    private boolean warningMessageShown = false;
    public OptionsDlg(java.awt.Frame parent, boolean modal)
    {
	super(parent, modal);
	initComponents();
    }    
    public OptionsDlg(java.awt.Frame parent, boolean modal, OptionsDB optionsDB) {
        super(parent, modal);
        initComponents();
        this.optionsDB = optionsDB;
        lstSequence.setModel(lstModel);
        String logFileName = optionsDB.logFileName;
	String chxPfConLocation = optionsDB.chxPfConLocation;
        int port = optionsDB.port;
        Vector<String> sequence = optionsDB.sequence;
        tfLogFile.setText(logFileName);
	tfChxPfConLocation.setText(chxPfConLocation);
        if (port > 0)
            tfPort.setText(Integer.toString(port));        
        for (String strPort : sequence)
        {
            lstModel.addElement(strPort);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        jPanel1 = new javax.swing.JPanel();
        tabbedPane = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        tfPort = new javax.swing.JTextField();
        tfKnockPort = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        btnAdd = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstSequence = new javax.swing.JList();
        btnUp = new javax.swing.JButton();
        btnDown = new javax.swing.JButton();
        btnRemove = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        tfLogFile = new javax.swing.JTextField();
        btnLogFile = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        tfChxPfConLocation = new javax.swing.JTextField();
        btnChxPfConLocation = new javax.swing.JButton();
        btnOk = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.X_AXIS));

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Options");
        jPanel1.setName("Options");
        jLabel1.setText("Port to open");

        tfPort.addFocusListener(new java.awt.event.FocusAdapter()
        {
            public void focusGained(java.awt.event.FocusEvent evt)
            {
                tfPortFocusGained(evt);
            }
        });

        tfKnockPort.addFocusListener(new java.awt.event.FocusAdapter()
        {
            public void focusGained(java.awt.event.FocusEvent evt)
            {
                tfKnockPortFocusGained(evt);
            }
        });
        tfKnockPort.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                tfKnockPortKeyReleased(evt);
            }
        });

        jLabel2.setText("New port");

        btnAdd.setText("Add");
        btnAdd.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnAddActionPerformed(evt);
            }
        });

        lstSequence.setModel(new javax.swing.AbstractListModel()
        {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lstSequence.addFocusListener(new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                lstSequenceFocusLost(evt);
            }
        });
        lstSequence.addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                lstSequenceMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(lstSequence);

        btnUp.setText("Up");
        btnUp.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnUpActionPerformed(evt);
            }
        });

        btnDown.setText("Down");
        btnDown.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnDownActionPerformed(evt);
            }
        });

        btnRemove.setText("Remove");
        btnRemove.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnRemoveActionPerformed(evt);
            }
        });
        btnRemove.addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                btnRemoveMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE)
                            .add(tfKnockPort, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE)))
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfPort, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(btnAdd, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE)
                    .add(btnUp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE)
                    .add(btnDown, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE)
                    .add(btnRemove, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(tfKnockPort, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnAdd))
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(34, 34, 34)
                        .add(btnUp)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnDown)
                        .add(34, 34, 34)
                        .add(btnRemove))
                    .add(jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(tfPort, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        tabbedPane.addTab("Knock Sequence", jPanel2);

        jLabel3.setText("CHX log file location");

        tfLogFile.setColumns(19);

        btnLogFile.setText("...");
        btnLogFile.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnLogFileActionPerformed(evt);
            }
        });

        jLabel4.setText("ChxPfCon.exe location");

        tfChxPfConLocation.setColumns(19);
        tfChxPfConLocation.setMaximumSize(new java.awt.Dimension(6, 20));

        btnChxPfConLocation.setText("...");
        btnChxPfConLocation.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnChxPfConLocationActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel3)
                    .add(jLabel4)
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(tfChxPfConLocation, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(tfLogFile, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(btnChxPfConLocation, 0, 0, Short.MAX_VALUE)
                            .add(btnLogFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, Short.MAX_VALUE))))
                .addContainerGap(8, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(btnLogFile)
                    .add(tfLogFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(28, 28, 28)
                .add(jLabel4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnChxPfConLocation)
                    .add(tfChxPfConLocation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(149, Short.MAX_VALUE))
        );
        tabbedPane.addTab("CHX Settings", jPanel3);

        btnOk.setText("OK");
        btnOk.setPreferredSize(new java.awt.Dimension(67, 23));
        btnOk.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnOkActionPerformed(evt);
            }
        });

        btnCancel.setText("Cancel");
        btnCancel.addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                btnCancelMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 268, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(47, 47, 47)
                        .add(btnOk, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 83, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 85, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 299, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnOk, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        getContentPane().add(jPanel1);
        jPanel1.getAccessibleContext().setAccessibleName("Options");
        jPanel1.getAccessibleContext().setAccessibleDescription("Options");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void tfPortFocusGained(java.awt.event.FocusEvent evt)//GEN-FIRST:event_tfPortFocusGained
    {//GEN-HEADEREND:event_tfPortFocusGained
	//deselect list
        if(lstSequence.getSelectedIndex() != -1)
            lstSequence.clearSelection();
	updateButtons();
    }//GEN-LAST:event_tfPortFocusGained

    private void btnChxPfConLocationActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnChxPfConLocationActionPerformed
    {//GEN-HEADEREND:event_btnChxPfConLocationActionPerformed
	String file = tfChxPfConLocation.getText();
        file.trim();
        JFileChooser fc = new JFileChooser(file);
        fc.setFileFilter(new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                if (f.isDirectory())
                    return true;
                String s = f.getName();
		return s.equals("ChxPfCon.exe");
//                int i = s.lastIndexOf('.');
//                if (i < 0)
//                    return false;
//                s = s.substring(i + 1);
//                return s.equals("exe");
            }
            public String getDescription() {
                return "ChxPfCon.exe";
            }
        });
        if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {       
            tfChxPfConLocation.setText(fc.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_btnChxPfConLocationActionPerformed

    private void btnAddActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnAddActionPerformed
    {//GEN-HEADEREND:event_btnAddActionPerformed
	btnAddAction();
    }//GEN-LAST:event_btnAddActionPerformed

    private void btnUpActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnUpActionPerformed
    {//GEN-HEADEREND:event_btnUpActionPerformed
	int index = lstSequence.getSelectedIndex();
        if (index == -1 || index == 0)
            return;
        Object item = lstModel.remove(index);
        lstModel.add(index - 1, item);
        lstSequence.setSelectedIndex(index - 1);
        updateButtons();
    }//GEN-LAST:event_btnUpActionPerformed

    private void btnDownActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnDownActionPerformed
    {//GEN-HEADEREND:event_btnDownActionPerformed
	int index = lstSequence.getSelectedIndex();
        if (index == -1 || (index == lstModel.getSize() - 1))
            return;
        Object item = lstModel.remove(index);
        lstModel.add(index + 1, item);
        lstSequence.setSelectedIndex(index + 1);
        updateButtons();
    }//GEN-LAST:event_btnDownActionPerformed

    private void btnRemoveActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnRemoveActionPerformed
    {//GEN-HEADEREND:event_btnRemoveActionPerformed
	int index = lstSequence.getSelectedIndex();
        if (index == -1)
            return;
        lstModel.remove(index);
    }//GEN-LAST:event_btnRemoveActionPerformed

    private void btnOkActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnOkActionPerformed
    {//GEN-HEADEREND:event_btnOkActionPerformed
	String strPort = tfPort.getText().trim();
	if(!strPort.matches("^[0-9]+$"))
	{
	    JOptionPane.showMessageDialog(this, "Please specify the port to open (must be numeric)", "Options", JOptionPane.WARNING_MESSAGE);
	    return;
	}
	int port = Integer.valueOf(strPort);
	if (lstModel.size() == 0) {
	    JOptionPane.showMessageDialog(this, "Please specify the knock sequence", "Options", JOptionPane.WARNING_MESSAGE);
	    warningMessageShown = true;
	    return;
	}
	String logfileName = tfLogFile.getText().trim();
	if (logfileName.equals("")) {
	    JOptionPane.showMessageDialog(this, "Please specify the CHX log-file location", "Options", JOptionPane.WARNING_MESSAGE);
	    return;
	}
	String chxPfConLocation = tfChxPfConLocation.getText().trim();
	if (chxPfConLocation.equals("")) {
	    JOptionPane.showMessageDialog(this, "Please specify the location of ChxPfCon.exe", "Options", JOptionPane.WARNING_MESSAGE);
	    return;
	}
	Vector<String> sequence = new Vector<String>();
	for (int i = 0; i < lstModel.size(); i++)
	    sequence.add((String)lstModel.get(i));
	String pfConLocation = "hello world";
	optionsDB.saveOptions(logfileName, port, sequence, chxPfConLocation);
	dispose();
    }//GEN-LAST:event_btnOkActionPerformed

    private void btnLogFileActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnLogFileActionPerformed
    {//GEN-HEADEREND:event_btnLogFileActionPerformed
	String file = tfLogFile.getText();
        file.trim();
        JFileChooser fc = new JFileChooser(file);
        fc.setFileFilter(new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                if (f.isDirectory())
                    return true;
                String s = f.getName();
                int i = s.lastIndexOf('.');
                if (i < 0)
                    return false;
                s = s.substring(i + 1);
                return s.equals("log");
            }
            public String getDescription() {
                return "CHX-I log file filter";
            }
        });
        if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {       
            tfLogFile.setText(fc.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_btnLogFileActionPerformed

    private void btnAddAction()
    {
        String strPort = tfKnockPort.getText();
        strPort = strPort.trim();
        int iPort = 0;
        
        try { // check if it's a number
            iPort = Integer.valueOf(strPort);
        } catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(null, "Port must be a number", "Options", JOptionPane.WARNING_MESSAGE);
            warningMessageShown = true; //set flag so tfKnockPortKeyReleased() can ignore the return key action sent to it
            return;
        }
        
        if (iPort < 1 || iPort > 65535) {
            JOptionPane.showMessageDialog(this, "Port must be a number ranging from 1 to 65535", "Options", JOptionPane.WARNING_MESSAGE);
            warningMessageShown = true; //set flag so tfKnockPortKeyReleased() can ignore the return key action sent to it
            return;
        }
        
//        if (lstModel.contains(strPort)) {
//            JOptionPane.showMessageDialog(this, "Port " + strPort + " was already added into the list", "Options", JOptionPane.WARNING_MESSAGE);
//            return;
//        }
        
        lstModel.addElement(strPort);
        
        //System.out.println("jScrollPane1.getVerticalScrollBar().getValue() = " + jScrollPane1.getVerticalScrollBar().getValue());
        //System.out.println("jScrollPane1.getVerticalScrollBar().getMaximum() = " + jScrollPane1.getVerticalScrollBar().getMaximum());
        
        //FIXME: scrollbar only scrolls down as far as the penultimate list entry
        jScrollPane1.getVerticalScrollBar().setValue(jScrollPane1.getVerticalScrollBar().getMaximum()); //scroll down to the bottom
                
        tfKnockPort.setText("");  //clear text box
        btnAdd.setEnabled(false); //disable add button
    }
    
    private void tfKnockPortKeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_tfKnockPortKeyReleased
    {//GEN-HEADEREND:event_tfKnockPortKeyReleased
	if(warningMessageShown) //set in the warning message code so the return key passed on can be ignored here (otherwise you can get stuck in a loop)
            warningMessageShown = false; //clear flag
        else
        {
            if(tfKnockPort.getText().length() != 0) //if there's some text in the box
            {
                btnAdd.setEnabled(true); //enable the 'add' button
                if(evt.getKeyCode() == 10) //if return/enter pressed
                {
                    btnAddAction();
                }
            }
            else
                btnAdd.setEnabled(false); //disable 'add' button
        }  
    }//GEN-LAST:event_tfKnockPortKeyReleased

    private void lstSequenceMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_lstSequenceMouseClicked
    {//GEN-HEADEREND:event_lstSequenceMouseClicked
	updateButtons();
    }//GEN-LAST:event_lstSequenceMouseClicked

    private void lstSequenceFocusLost(java.awt.event.FocusEvent evt)//GEN-FIRST:event_lstSequenceFocusLost
    {//GEN-HEADEREND:event_lstSequenceFocusLost
	updateButtons();
    }//GEN-LAST:event_lstSequenceFocusLost

    private void btnRemoveMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_btnRemoveMouseClicked
    {//GEN-HEADEREND:event_btnRemoveMouseClicked
	int size = lstSequence.getModel().getSize();
        //move selected index to item above in list
        if(lastSelectedIndex == 0 && size > 0) //if the top one was removed and there are more below
            lstSequence.setSelectedIndex(0); //set to the new top one
        else if(lastSelectedIndex > 0 && size > lastSelectedIndex) //else if one in the list was removed and there are more below
            lstSequence.setSelectedIndex(lastSelectedIndex); //set to the one below (same index as one just removed)
        else if(lastSelectedIndex > 0) //else if there are more above the one that has been removed
            lstSequence.setSelectedIndex(lastSelectedIndex-1); //set index to the one above
        updateButtons();
    }//GEN-LAST:event_btnRemoveMouseClicked

    private void tfKnockPortFocusGained(java.awt.event.FocusEvent evt)//GEN-FIRST:event_tfKnockPortFocusGained
    {//GEN-HEADEREND:event_tfKnockPortFocusGained
	//deselect list
        if(lstSequence.getSelectedIndex() != -1)
            lstSequence.clearSelection();
	updateButtons();
    }//GEN-LAST:event_tfKnockPortFocusGained

    private void updateButtons()
    {
        int index = lstSequence.getSelectedIndex();
        int size = lstSequence.getModel().getSize();
        
        if(index != -1) //if there's something selected in the list
            btnRemove.setEnabled(true);
        else
            btnRemove.setEnabled(false);
        
        if(index != -1 && index < size-1) //if not last in list
            btnDown.setEnabled(true);
        else
            btnDown.setEnabled(false);
        
        if(index > 0) //if lower than top place
            btnUp.setEnabled(true);
        else
            btnUp.setEnabled(false);
    }
    
    private void btnCancelMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_btnCancelMouseClicked
    {//GEN-HEADEREND:event_btnCancelMouseClicked
	dispose();
    }//GEN-LAST:event_btnCancelMouseClicked
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
	java.awt.EventQueue.invokeLater(new Runnable()
	{
	    public void run()
	    {
		new OptionsDlg(new javax.swing.JFrame(), true).setVisible(true);
	    }
	});
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnChxPfConLocation;
    private javax.swing.JButton btnDown;
    private javax.swing.JButton btnLogFile;
    private javax.swing.JButton btnOk;
    private javax.swing.JButton btnRemove;
    private javax.swing.JButton btnUp;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList lstSequence;
    private javax.swing.JTabbedPane tabbedPane;
    private javax.swing.JTextField tfChxPfConLocation;
    private javax.swing.JTextField tfKnockPort;
    private javax.swing.JTextField tfLogFile;
    private javax.swing.JTextField tfPort;
    // End of variables declaration//GEN-END:variables
    
}
